module Data.SpirV.Reflect.Enums.SpirvStorageClass where

import Data.SpirV.Reflect.Enums.Common

newtype StorageClass = StorageClass Int32
  deriving newtype (Eq, Ord, Show, Enum, Bounded)

pattern StorageClassUniformConstant :: StorageClass
pattern StorageClassUniformConstant = StorageClass 0

pattern StorageClassInput :: StorageClass
pattern StorageClassInput = StorageClass 1

pattern StorageClassUniform :: StorageClass
pattern StorageClassUniform = StorageClass 2

pattern StorageClassOutput :: StorageClass
pattern StorageClassOutput = StorageClass 3

pattern StorageClassWorkgroup :: StorageClass
pattern StorageClassWorkgroup = StorageClass 4

pattern StorageClassCrossWorkgroup :: StorageClass
pattern StorageClassCrossWorkgroup = StorageClass 5

pattern StorageClassPrivate :: StorageClass
pattern StorageClassPrivate = StorageClass 6

pattern StorageClassFunction :: StorageClass
pattern StorageClassFunction = StorageClass 7

pattern StorageClassGeneric :: StorageClass
pattern StorageClassGeneric = StorageClass 8

pattern StorageClassPushConstant :: StorageClass
pattern StorageClassPushConstant = StorageClass 9

pattern StorageClassAtomicCounter :: StorageClass
pattern StorageClassAtomicCounter = StorageClass 10

pattern StorageClassImage :: StorageClass
pattern StorageClassImage = StorageClass 11

pattern StorageClassStorageBuffer :: StorageClass
pattern StorageClassStorageBuffer = StorageClass 12

pattern StorageClassCallableDataKHR :: StorageClass
pattern StorageClassCallableDataKHR = StorageClass 5328

pattern StorageClassCallableDataNV :: StorageClass
pattern StorageClassCallableDataNV = StorageClass 5328

pattern StorageClassIncomingCallableDataKHR :: StorageClass
pattern StorageClassIncomingCallableDataKHR = StorageClass 5329

pattern StorageClassIncomingCallableDataNV :: StorageClass
pattern StorageClassIncomingCallableDataNV = StorageClass 5329

pattern StorageClassRayPayloadKHR :: StorageClass
pattern StorageClassRayPayloadKHR = StorageClass 5338

pattern StorageClassRayPayloadNV :: StorageClass
pattern StorageClassRayPayloadNV = StorageClass 5338

pattern StorageClassHitAttributeKHR :: StorageClass
pattern StorageClassHitAttributeKHR = StorageClass 5339

pattern StorageClassHitAttributeNV :: StorageClass
pattern StorageClassHitAttributeNV = StorageClass 5339

pattern StorageClassIncomingRayPayloadKHR :: StorageClass
pattern StorageClassIncomingRayPayloadKHR = StorageClass 5342

pattern StorageClassIncomingRayPayloadNV :: StorageClass
pattern StorageClassIncomingRayPayloadNV = StorageClass 5342

pattern StorageClassShaderRecordBufferKHR :: StorageClass
pattern StorageClassShaderRecordBufferKHR = StorageClass 5343

pattern StorageClassShaderRecordBufferNV :: StorageClass
pattern StorageClassShaderRecordBufferNV = StorageClass 5343

pattern StorageClassPhysicalStorageBuffer :: StorageClass
pattern StorageClassPhysicalStorageBuffer = StorageClass 5349

pattern StorageClassPhysicalStorageBufferEXT :: StorageClass
pattern StorageClassPhysicalStorageBufferEXT = StorageClass 5349

pattern StorageClassCodeSectionINTEL :: StorageClass
pattern StorageClassCodeSectionINTEL = StorageClass 5605

pattern StorageClassDeviceOnlyINTEL :: StorageClass
pattern StorageClassDeviceOnlyINTEL = StorageClass 5936

pattern StorageClassHostOnlyINTEL :: StorageClass
pattern StorageClassHostOnlyINTEL = StorageClass 5937

pattern StorageClassMax :: StorageClass
pattern StorageClassMax = StorageClass 0x7fffffff
